import { IScheduler } from './../descriptors/IScheduler';
import * as Firebase from 'firebase-admin';
import { Handlers } from '../utils/Handlers';
import { ITask } from '../descriptors/ITask';
declare class Scheduler implements IScheduler {
    private jobList;
    private redundancyService;
    private jobCompletionHandler;
    constructor(reference: Firebase.database.Reference, jobCompletionHandler: Handlers.JobCompletionHandler);
    private getJobCallback(key);
    private scheduleJob(job);
    queueExisting(tasks: Array<ITask>): Promise<void>;
    get(key: string): Promise<ITask>;
    getPendingCount(): number;
    schedule(task: ITask): Promise<ITask>;
    cancel(key: string): Promise<void>;
}
export { Scheduler };
