"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Utils {
    static sleep(millis) {
        return new Promise((resolve) => setTimeout(resolve, millis));
    }
    static isNumeric(val) {
        if (isNaN(val)) {
            return false;
        }
        const x = parseFloat(val);
        return (x | 0) === x;
    }
    static isValidKey(key) {
        if (typeof key !== "string") {
            return false;
        }
        if (key.length === 0) {
            return false;
        }
        if (/[\[\].#$\/\u0000-\u001F\u007F]/.test(key)) {
            return false;
        }
        return true;
    }
}
exports.Utils = Utils;
