"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class BonfireJob {
    constructor(key, type, datetime) {
        this.key = null;
        this.type = null;
        this.scheduledDateTime = null;
        this.payload = null;
        if (!key || key.length == 0) {
            throw new Error('Invalid key provided.');
        }
        if (!type || type.length == 0) {
            throw new Error('The job type must be a valid string and with a length greater than 0.');
        }
        this.key = key;
        this.type = type;
        this.scheduledDateTime = datetime;
    }
    static fromJson(data) {
        let job = new BonfireJob(data['id'], data['type'], new Date(data['scheduled_date_time']));
        if (data['payload']) {
            job.setPayload(data['payload']);
        }
        return job;
    }
    getKey() {
        return this.key;
    }
    setKey(key) {
        this.key = key;
    }
    getType() {
        return this.type;
    }
    setType(type) {
        this.type = type;
    }
    getScheduledDateTime() {
        return this.scheduledDateTime;
    }
    setScheduledDateTime(date) {
        this.scheduledDateTime = date;
    }
    getPayload() {
        return this.payload;
    }
    setPayload(payload) {
        this.payload = payload;
    }
    asJson() {
        let obj = {
            'id': this.key,
            'type': this.type,
            'scheduled_date_time': this.scheduledDateTime.getTime()
        };
        if (this.payload) {
            obj['payload'] = JSON.stringify(this.payload);
        }
        return obj;
    }
}
exports.BonfireJob = BonfireJob;
